#ifndef Headers_h
#define Headers_h

#include "HecRunHeader2002v1.h"
#include "EmecRunHeader2002v0.h"
#include "SlowControl2002v0.h"
#include "GlobalHeader2002v0.h"

/*! - Class:    Headers
      - Author:   Ian Gable (igable@uvic.ca)
      - Date:      05/22/2003
      - Description: A simple class which holds pointers to all the different header objects.
  */


class Headers {

 public:


  /** Use this contructor
    *@param hecHeader the Hec Run Header Objects
    *@param emecHeader the Emec Header Object
    *@param slowHeader the Slow Control Header Object
    *@param globalHeader the Global Run Header Object
    */
  Headers(HecRunHeader2002v1* hecHeader, EmecRunHeader2002v0* emecHeader, SlowControl2002v0* slowHeader, GlobalHeader2002v0* globalHeader);

  //! Return a pointer to the HecRun Header Object.
  HecRunHeader2002v1* hec(){ return m_hecHeader; };

  //! Return a Pointer to the Emec Run Header Object
  EmecRunHeader2002v0* emec(){ return m_emecHeader; };

  //! Return A pointer to the Slow Control Run Header Object.
  SlowControl2002v0* slow(){ return m_slowHeader; };

  //! Return a Pointer to the Global run header object.
  GlobalHeader2002v0* global(){ return m_globalHeader; };

 private:

  HecRunHeader2002v1* m_hecHeader;
  EmecRunHeader2002v0* m_emecHeader;
  SlowControl2002v0* m_slowHeader;
  GlobalHeader2002v0* m_globalHeader;

};
#endif
