
// (Special "header" just for doxygen )

/*! @mainpage  package TBRootAna

This package contains classes for manipulating the Hec Test beam NTuple Data 
using ROOT. The package will produce an executable which can be run to perform 
the analysis that you want.

\section Useralg UserAlg: The Starting point

UserAlg is where you need to make your changes to run an analysis you design.
	- UserAlg

\section dataclasses Data Classes

These classes provide you, the user, with access to all the data contained in the
NTuple.

	- Event
	- Headers
		- EmecRunHeader2002v0
		- HecRunHeader2002v1
		- SlowControl2002v0
		- GlobalHeader2002v0
	- HecCell
	- EmecCell
	- Geometry

\section systemclasses System Algorithm Classes
These sub classes can be run to do various different things with the data for 
you. You can load/run these algorithms from within your UserAlg

	- SystemAlg
            - PlotAllCellsAlg
            - HecClusterBuildAlg
	    - HecEnergyLayerAlg
	    - CalibrationAlg


\section notes Release Notes

\include release.notes 


\section reference Reference Document
  See UVic 
  <a href="http://particle.phys.uvic.ca/~web-atlas/atlas/hec/">Hec webpage</a>.



*/
